﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Win32;
using System.Reflection;

namespace Kaushik.Spot.CodeGenerator
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Assembly service = null;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

        }

        private void browse_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog file = new OpenFileDialog();

            file.Filter = "*.dll|*.exe";

            Nullable<bool> result = file.ShowDialog();

            if (result.HasValue)
            {
                assemblyFullPath.Text = file.FileName;

                try
                {
                    service = Assembly.LoadFile(assemblyFullPath.Text);
                    Type[] allTypes = service.GetTypes();
                    typesList.ItemsSource = from t in allTypes
                                            where t.GetCustomAttributesData().FirstOrDefault(a => a.ToString() == "[Kaushik.Spot.Library.SpotServiceAttribute()]") != null 
                                            select t.FullName;
                }
                catch (Exception error)
                {
                    MessageBox.Show(error.Message);
                }

            }
        }

        private void generate_Click(object sender, RoutedEventArgs e)
        {
            if (typesList.SelectedIndex > -1)
            {
                if (!String.IsNullOrEmpty(namespaceName.Text)
                    && !String.IsNullOrEmpty(proxyClassName.Text)
                    && !String.IsNullOrEmpty(server.Text)
                    && !String.IsNullOrEmpty(port.Text))
                {
                    string proxyCode = ProxyBody.GenerateProxy(service.GetType(typesList.SelectedValue.ToString()), namespaceName.Text,
                        proxyClassName.Text, server.Text, Convert.ToInt32(port.Text));

                    ShowProxyCode window = new ShowProxyCode(proxyCode);

                    window.Show();

                }
                else
                {
                    MessageBox.Show("Please enter all information.");
                }
            }
            else
            {
                MessageBox.Show("Please select a type.");
            }
        }
    }
}
