﻿/**********************************************************************************
 This class is generated using Kaushik.Spot.CodeGenerator, 
 any change to this file may lead to malfunction.
 **********************************************************************************/
using System;
using System.Net.Sockets;
using Kaushik.Spot.Library;

namespace Kaushik.Spot.PhoneControllerApp
{
    public class BlinkLedService
    {
        private string _serverIp;
        private short _port;
        private short _bufferSize;
        private int _socketClientTimeout;
        private short _chunkSize;
        private string _serviceName;
        private ICryptographicServiceProvider _cipher;
        private ISpotSocketClient _socketClient;


        public BlinkLedService(ICryptographicServiceProvider cipher = null, SpotSocketProvider provider = SpotSocketProvider.Tcp,
            string serverIp = "192.167.1.6", short port = 8080)
        {
            _serverIp = serverIp;
            _port = port;
            _bufferSize = 5120;
            _socketClientTimeout = 50000000;
            _chunkSize = 500;
            _serviceName = "Kaushik.Spot.MicroServer.IBlinkLedService";
            _cipher = cipher;
            _socketClient = SpotSocketFactory.GetClientProvider(_serverIp, provider, _port, _bufferSize, _socketClientTimeout, _chunkSize);
        }


        private string encrypt(string plainText)
        {
            if (_cipher == null)
            {
                return plainText;
            }
            else
            {
                return _cipher.Encrypt(plainText);
            }
        }


        private string decrypt(string cipherText)
        {
            if (_cipher == null)
            {
                return cipherText;
            }
            else
            {
                return _cipher.Decrypt(cipherText);
            }
        }

        public System.Boolean ApplyPattern(System.Int32 pattern)
        {
            string request = null;
            ServiceCommand command = new ServiceCommand();
            ServiceResult result = new ServiceResult();
            string response;
            System.Boolean finalResult = false;
            using (Socket socket = _socketClient.CreateClient())
            {
                command.ServiceName = _serviceName;
                command.Method = "ApplyPattern";
                command.Parameters = new object[] { pattern };
                request = encrypt(command.Serialize());
                _socketClient.Send(request);
                _socketClient.Receive(out response);
                result.Deserialize(decrypt(response));
                finalResult = Convert.ToBoolean(result.Result);
                if (!String.IsNullOrEmpty(result.Error))
                {
                    throw new Exception(result.Error);
                }
            }
            return finalResult;
        }

    }
}